Setting up the Xplat CLI repo


* Create a fork from the [repo](https://github.com/Azure/azure-xplat-cli)
* Clone the forked repo at a location say “D:\sdk”
```
git clone git@github.com:your-github-username/azure-xplat-cli.git
cd azure-xplat-cli
git checkout dev
git remote add upstream git@github.com:Azure/azure-xplat-cli.git
git pull upstream dev
git push origin dev (if there are any updates)

Note: It is a best practice to create a separate branch for your feature from the dev branch. In this way the dev branch in your fork can always be synced easily with upstream and is not polluted with your current changes.
git checkout -b mybranch 
git push origin mybranch
```

* Installing the required npm modules from the root directory [```npm install```](https://docs.npmjs.com/cli/install)
  * It looks at the file "azure-xplat-cli/package.json" and will install all the module dependencies specified in it.
  * Xplat-CLI depends on [azure-sdk-for-node](https://github.com/Azure/azure-sdk-for-node), specified as ```"azure": "x.x.x",``` under dependencies. The node SDK contains the autogenerated service clients that make the underlying REST request when a command is executed from the cmd prompt.
* Generate the metadata for help
  * Execute the command ```node bin/azure --gen``` 
* **Optional** Installing this source code at a global location. From the root directory execute```npm install -g .```
  * Thus, when a command is executed ```azure site list```, it is executing the code that was installed from the repo at the global location
  * If this optional step is not performed, then the commands can be executed from the root directory of the current repo like this ```node bin/azure site list```

* To verify the installation, execute the following commands:
```
azure -v # It should display the current version number of xplat cli, mentioned in package.json
azure -h # It should display the help for different commands supported by xplat cli
```

Now, the CLI is ready for executing current commands and developing new commands.
